"""Backwards compat for rads.userdata"""
import warnings
from ._users import UserData as _UserData
from ._users import UserDomain as _UserDomain
from .compat import RadsDeprecation

# pylint: disable=unused-import
from ._users import CpuserError as UserDataError


class UserData(_UserData):
    """compat for rads.userdata.UserData"""

    def __init__(self, *args, **kwargs):
        warnings.warn(
            'rads.userdata is deprecated. Import directly from rads',
            RadsDeprecation,
            stacklevel=3,
        )
        super().__init__(*args, **kwargs)


class UserDomain(_UserDomain):
    """compat for rads.userdata.UserDomain"""

    def __init__(self, *args, **kwargs):
        warnings.warn(
            'rads.userdata is deprecated. Import directly from rads',
            RadsDeprecation,
            stacklevel=3,
        )
        super().__init__(*args, **kwargs)
